"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}Object.defineProperty(exports,"__esModule",{value:!0});var path=_interopDefault(require("path")),t=require("@babel/types"),assert=_interopDefault(require("assert")),standalone=require("@babel/standalone"),register=require("@babel/register"),register__default=_interopDefault(register),evaluatePath=_interopDefault(require("babel-helper-evaluate-path")),resolve=_interopDefault(require("resolve")),taddy=require("taddy"),tsPreset=_interopDefault(require("@babel/preset-typescript")),reactPreset=_interopDefault(require("@babel/preset-react")),envPreset=_interopDefault(require("@babel/preset-env")),core=require("@taddy/core"),core$1=require("@babel/core"),fs=_interopDefault(require("fs")),stringHash=_interopDefault(require("string-hash"));function _extends(){return(_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var r=arguments[t];for(var n in r)Object.prototype.hasOwnProperty.call(r,n)&&(e[n]=r[n])}return e}).apply(this,arguments)}function _objectWithoutPropertiesLoose(e,t){if(null==e)return{};var r,n,s={},i=Object.keys(e);for(n=0;n<i.length;n++)t.indexOf(r=i[n])>=0||(s[r]=e[r]);return s}const MACRO_NAME="taddy.macro",PACKAGE_NAME="taddy";function getRootDir(){return process.cwd()}function getCacheDir(){return path.join(__dirname,"..")}const cache=new WeakMap;class BindingError extends Error{}function isIterable(e){return Symbol.iterator in Object(e)}function addBinding(e,t,r){if(isIterable(r))for(let n of r)addBinding(e,t,n);else e.set(t,(e.get(t)||new Set).add(r))}function isFunctionArgument(e){return"params"===e.listKey&&e.parentPath.isFunction()}function findBindings(e,{throwError:t=!1}={}){function r(r,n,i){n.parentPath.isMemberExpression()?n=n.parentPath.get("object"):n.parentPath.isObjectPattern()&&(n=n.parentPath.parentPath);const{parentPath:o,node:a}=n;if(!(o.isExpression()||o.isSpreadElement()||o.isVariableDeclarator()&&o.node.init===a||o.isObjectProperty()&&(o.node.value===a||o.node.computed)))return;if(!("name"in a)||"string"!=typeof a.name)return;const{name:c}=a,p=e.scope.getBinding(c),l=r.scope.getBinding(c);if(!l)return;if(p!==l)return;if(l.constantViolations.length>0)throw new BindingError("CONSTANT VIOLATION");const{path:u}=l;if(i.has(l))addBinding(i,l,n);else if(isFunctionArgument(u)){if(t)throw new BindingError("FUNCTION ARGUMENT")}else if(addBinding(i,l,n),!u.isImportSpecifier())for(let[e,t]of s(u))addBinding(i,e,t)}const n=new Set;function s(e){if(e.isObjectPattern(),cache.has(e))return cache.get(e);const t=new Map;return n.has(e)||(n.add(e),e.isIdentifier()&&r(e,e,t),e.traverse({Identifier(n){r(e,n,t)}}),cache.set(e,t)),t}return s(e)}function getPathsByBindings(e){const t=new Set;for(let r of e.keys())r.path.isImportSpecifier()||r.path.isVariableDeclarator()?t.add(r.path.parentPath):t.add(r.path);return t}function buildCodeByPath(e){return Array.from(getPathsByBindings(findBindings(e,{throwError:!0}))).sort((e,t)=>e.node.start-t.node.start).map(e=>e.toString()).join("\n")}standalone.registerPreset("@babel/preset-typescript",tsPreset),standalone.registerPreset("@babel/preset-react",reactPreset),standalone.registerPreset("@babel/preset-env",envPreset);const DEFAULT_PRESETS=[["@babel/preset-typescript",{allExtensions:!0,isTSX:!0}],["@babel/preset-env",{targets:{node:"12"},useBuiltIns:!1,ignoreBrowserslistConfig:!0}]],EXTENSIONS=[".es6",".es",".tsx",".ts",".jsx",".js",".mjs"],macroRe=new RegExp(MACRO_NAME.replace(".","\\."),"g"),EVAL_FILENAME_POSTFIX="@__TADDY_EVALUATE__",nodeRequire=new Function("require","return typeof require !== 'undefined'\n        ? require\n        : (typeof globalThis !== 'undefined' ? globalThis : global).require; ")(module.require);function isTaddyEvaluation(e){return e.filename.includes(EVAL_FILENAME_POSTFIX)}function evaluate(e){const t=evaluatePath(e);if(t.confident)return findBindings(e),{value:t.value};let r="",n="";try{const t="__taddy__";r=buildCodeByPath(e).replace(macroRe,PACKAGE_NAME).concat(`\n\n;${t}(${e.toString()})`);const{opts:s}=e.hub.file,i=path.extname(s.filename),o=path.basename(s.filename,i),a=path.dirname(s.filename),c={babelrc:!1,configFile:!1,filename:path.join(a,o+EVAL_FILENAME_POSTFIX+i),plugins:[],presets:[...DEFAULT_PRESETS]};if(({code:n}=standalone.transform(r,c)||{}),!n)return{};const p=new Function("require",t,n);let l;return register__default(_extends({},c,{extensions:EXTENSIONS})),p(e=>{if(e===PACKAGE_NAME)return taddy;const t=resolve.sync(e,{extensions:EXTENSIONS,basedir:path.dirname(s.filename)});return nodeRequire(t)},e=>{l=e}),register.revert(),{value:l}}catch(e){return{error:e}}}function getObjectPropertyKey(e){return e.isIdentifier()?e.node.name:e.isLiteral()&&"value"in e.node?String(e.node.value):null}function mergeObjectProperties(e){const r=new Map;function n(e,t){r.delete(e),r.set(e,t)}for(const r of e){if(!t.isObjectProperty(r)){n(r,r);continue}const{key:e}=r;t.isIdentifier(e)?n(e.name,r):t.isStringLiteral(e)?n(e.value,r):n(r,r)}return Array.from(r.values())}function mergeObjects(e){const t=[];return e.forEach(e=>{t.push(...e.properties)}),mergeObjectProperties(t)}function isTaddy(e){const{path:t}=e;return!!t.isImportSpecifier()&&("taddy"===t.parentPath.node.source.value&&"css"===t.node.imported.name||"mixin"===t.node.imported.name)}class BindingOptimizer{constructor(){this.cache=new Map}process(e){let t;try{t=findBindings(e)}catch(e){return}for(let[e,r]of t){if(isTaddy(e))continue;if(e.path.removed)continue;if(this.process(e.path),addBinding(this.cache,e,r),this.cache.get(e).size<e.references)continue;e.path.remove();const{parentPath:t}=e.path;t.isImportDeclaration()&&0===t.node.specifiers.length&&t.remove()}}}function apply(e){let r,n="";for(let s of e)"string"!=typeof s?(r&&n?(r=t.binaryExpression("+",r,t.stringLiteral(" "+n+" ")),r=t.binaryExpression("+",r,s)):r=n?t.binaryExpression("+",t.stringLiteral(n+" "),s):s,n=""):n+=(n?" ":"")+s;return r&&n&&(r=t.binaryExpression("+",r,t.stringLiteral(" "+n))),r||t.stringLiteral(n)}function optimizeStaticStyles(e){const r=[];let n=[];for(const s of e.get("properties")){if(!s.isObjectProperty())throw new Error("Cant optimize this path");const e=getObjectPropertyKey(s.get("key"));if(!e)return;const i=s.get("value");"className"!==e&&"style"!==e&&e!==core.VARS_KEY?i.isStringLiteral()?n.push(e+i.node.value):i.isBooleanLiteral()?n.push(e):n.push(t.binaryExpression("+",t.stringLiteral(e),i.node)):(n.length&&r.push(t.objectProperty(apply(n),t.booleanLiteral(!0))),r.push(s.node),n=[])}0!==r.length?(n.length&&r.push(t.objectProperty(apply(n),t.booleanLiteral(!0))),e.node.properties=r):e.replaceWith(apply(n))}function taggedTemplateToObject(e){const t=require("postcss"),r=require("postcss-js"),{quasis:n,expressions:s}=e.node.quasi,i={},o=/@\^var__\w+__/;let a="";for(let e=0;e<n.length;e++)if(a+=n[e].value.raw,s[e]){const t=`@^var__${e}__`;i[t]=s[e],a+=t}const c=t.parse(a);function p(e){const t=[];return e.replace(new RegExp(o,"g"),e=>{t.push(i[e])}),0===t.length?core$1.types.stringLiteral(e):core$1.types.templateLiteral(e.split(o).map(e=>core$1.types.templateElement({raw:e,cooked:e})),t)}return function e(t){const r=[];for(let n in t){const s=t[n];if(!0===s){r.push(core$1.types.spreadElement(i[n]));continue}const o=p(n.replace(/^&/,""));let a;a="object"==typeof s?e(s):p(String(s)),r.push(core$1.types.objectProperty(o,a,!core$1.types.isStringLiteral(o)))}return core$1.types.objectExpression(r)}(r.objectify(c))}function getType(e){return null==e?void 0:e.getTypeAtLocation(e.getDeclarations()[0])}class DynamicType{constructor({value:e,type:t}){this.value=e,this.type=t}}class UnionType extends Array{}function isRecord(e){var t;return"Record"===(null==e||null===(t=e.getAliasSymbol())||void 0===t?void 0:t.getEscapedName())}const STATIC_KEY=Symbol("__TADDY_STATIC_KEY__");function isStaticValue(e){return!e||"object"!=typeof e||!(e instanceof UnionType)&&(e[STATIC_KEY]||!1)}function filterValue(e){return String(e).startsWith("-")}function parseValue(e){var t;if(!e)return null;if(e.isAny()||e.isUnknown())return new DynamicType({value:null,type:e});if(isRecord(e))return parseRecord(e);if(e.isArray())return parseArray(e);if(e.isUnion())return new UnionType(...e.getUnionTypes().map(parseValue));if(e.isObject())return parseObject(e);let r=null==e?void 0:e.getText();if(!r||(null===(t=r)||void 0===t?void 0:t.includes("&")))return null;try{r=JSON.parse(r)}catch(t){return new DynamicType({value:r,type:e})}return filterValue(r)?null:r}function parseMixinParameters(e){return parseValue(getType(e))}function parseMixin(e){const t=getType(e);return 0===(null==t?void 0:t.getCallSignatures().length)?parseMixinParameters(e):null==t?void 0:t.getCallSignatures()[0].getParameters().map(parseMixinParameters)}function parseRecord(e){const[t,r]=e.getAliasTypeArguments(),n=parseValue(t),s=parseValue(r);return Array.isArray(n)?n.map(e=>({[e]:s,[STATIC_KEY]:s[STATIC_KEY]})):{[n]:s,[STATIC_KEY]:s[STATIC_KEY]}}function parseArray(e){const t=[];function r(e){const r=parseValue(e);if(!r)return;const n=isStaticValue(r);t[STATIC_KEY]=t[STATIC_KEY]&&n,t.push(n?r:new Set([].concat(r).filter(Boolean)))}t[STATIC_KEY]=!0;const n=e.getArrayElementTypeOrThrow();for(let e of n.getUnionTypes()||[n])r(e);return t}function parseObject(e){const t={};let r=!0;for(const s of null!==(n=null==e?void 0:e.getProperties())&&void 0!==n?n:[]){var n;const e=s.getEscapedName(),i=parseMixin(s);if(!i)continue;const o=isStaticValue(i);r=r&&o,t[e]=o?i:new Set([].concat(i).filter(Boolean))}return t[STATIC_KEY]=r,t}class TSProcessor{constructor(e){const{Project:t}=require("ts-morph");this.project=e instanceof t?e:new t(_extends({tsConfigFilePath:path.join(process.cwd(),"tsconfig.json")},e))}getTypeAtPos(e,t,r,n){let s=this.project.getSourceFile(e);return s&&s.getFullText()!==t?s.replaceText([0,s.getEnd()],t):s=this.project.createSourceFile(e,t,{overwrite:!0}),s.getDescendantAtStartWithWidth(r,n-r)}}function isUndefined(e){return e.isIdentifier()&&"undefined"===e.node.name}function getLiteralValue(path){try{return eval(path.toString())}catch(e){return getLiteralValue.FAIL}}function getHashedName(e,{postfix:t}){return core.config.nameGenerator.getName(e,"",{postfix:t}).join("")}getLiteralValue.FAIL=Symbol("FAILED_VALUE");const isCSSProperty=e=>"--"===e.slice(0,2)||/[\w-]/.test(e);let cachedTSProject;class Processor{constructor({config:e}){this.config=e}prepare(e){this.options=e,this.variables=[],this.classNameNodes=new WeakSet,this.optimizationPaths=new Set}get tsProject(){if(!this.config.typescript)throw new Error("TADDY: cant use typescript without enabled option");return cachedTSProject||(cachedTSProject=new TSProcessor(!0===this.config.typescript?{}:this.config.typescript))}isClassNameNode(e){return this.classNameNodes.has(e)}classNamesToNode(e){const r=[];for(const n in e){const s=e[n],i=t.identifier(n);let o;o="object"==typeof e[n]?t.objectExpression(this.classNamesToNode(e[n])):"boolean"==typeof e[n]?t.booleanLiteral(s):t.stringLiteral(String(s));const a=t.objectProperty(i,o);this.classNameNodes.add(a),r.push(a)}return r}stylesToNode(e,t,{postfix:r=""}={}){const{className:n}=taddy.$css({[e]:t},{postfix:r});return this.classNamesToNode(n)}processPropertyValue(e,r,{postfix:n,properties:s}){const i=r.get("key"),o=r.get("value"),a=Symbol("STOP"),c=e=>{var t;const r=null===(t=this.tsProject)||void 0===t?void 0:t.getTypeAtPos(this.options.filename,this.options.code,e.node.start||0,e.node.end||0);return r?parseValue(r.getType()):a};(()=>{if(!o.isLiteral()&&!isUndefined(o))return!1;const t=getLiteralValue(o);return t!==getLiteralValue.FAIL&&(s.push(...this.stylesToNode(e,t,{postfix:n})),!0)})()||(()=>{if(!o.isObjectExpression())return!1;this.process(o,{postfix:n+e});let r=[];for(const e of o.node.properties)this.isClassNameNode(e)?(r.length&&(s.push(t.objectProperty(i.node,t.objectExpression(r))),r=[]),s.push(e)):r.push(e);return r.length&&s.push(t.objectProperty(i.node,t.objectExpression(r))),!0})()||(()=>{if("composes"!==e||!o.isArrayExpression())return!1;if(""!==n)throw new Error("TADDY: composes could be used only on top level");for(const e of o.get("elements"))this.process(e);return!1})()||(()=>{if(!this.config.evaluate)return!1;const{value:t,error:i}=evaluate(o);return!i&&(s.push(...this.stylesToNode(e,t,{postfix:n})),this.optimizationPaths.add(r),!0)})()||(()=>{if(!this.config.typescript)return!1;let i;if(i="composes"===e&&o.isArrayExpression()?(e=>{const t=[];t[STATIC_KEY]=!0;for(let r of e.get("elements")){if(!r)return;const e=c(r);if(e===a)return;t[STATIC_KEY]=t[STATIC_KEY]&&isStaticValue(e),t.push(e)}return t})(o):c(o),i===a)return!1;if(isStaticValue(i))return s.push(...this.stylesToNode(e,i,{postfix:n})),this.optimizationPaths.add(r),!0;if("composes"===e)return!1;const p=[].concat(i);let l=!0;if(p.forEach(t=>{t instanceof DynamicType||!isStaticValue(t)?l=!1:taddy.$css({[e]:t},{postfix:n})}),!l)return!1;const u=getHashedName(e,{postfix:n}),d=this.options.addImport("h");return s.push(t.objectProperty(t.identifier(u),t.callExpression(d,[o.node]))),!0})()||(()=>{if(!this.config.CSSVariableFallback)return!1;if(this.options.mixin||"composes"===e||!isCSSProperty(e))return!1;const r="--"+getHashedName(e,{postfix:n});return this.variables.push(t.objectProperty(t.stringLiteral(r),o.node)),s.push(...this.stylesToNode(e,`var(${r})`,{postfix:n})),!0})()||s.push(r.node)}processObjectProperty(e,{postfix:r="",properties:n}){const s=e.get("key"),i=getObjectPropertyKey(s),o=()=>{if(!this.config.evaluate)return!1;const{value:i,error:o}=evaluate(s);return!o&&(s.replaceWith(t.stringLiteral(i)),this.processPropertyValue(i,e,{postfix:r,properties:n}),!0)};if("className"!==i&&"style"!==i&&null!==i)this.processPropertyValue(i,e,{postfix:r,properties:n});else{if(o())return;n.push(e.node)}}processSpreadElement(e,{postfix:t="",properties:r}){(()=>{if(!this.config.evaluate)return!1;const{value:n}=evaluate(e.get("argument"));if(!n)return!1;const{className:s}=taddy.$css(n,{postfix:t});return r.push(...this.classNamesToNode(s)),this.optimizationPaths.add(e),!0})()||(()=>{var n;if(!this.config.typescript)return!1;const{argument:s}=e.node,i=null===(n=this.tsProject)||void 0===n?void 0:n.getTypeAtPos(this.options.filename,this.options.code,s.start||0,s.end||0);if(!i)return!1;const o=parseValue(i.getType());if(!isStaticValue(o))return!1;const{className:a}=taddy.$css(o,{postfix:t});return r.push(...this.classNamesToNode(a)),this.optimizationPaths.add(e),!0})()||(this.process(e.get("argument")),r.push(e.node))}processLogicalExpression(e,t){this.process(e.get("left"),t),this.process(e.get("right"),t)}processObjectExpression(e,{postfix:t=""}){const r=[];for(const n of e.get("properties"))n.isObjectProperty()?this.processObjectProperty(n,{postfix:t,properties:r}):n.isSpreadElement()?this.processSpreadElement(n,{postfix:t,properties:r}):r.push(n.node);this.options.mixin||(e.node.properties=mergeObjectProperties(r))}processConditionalExpression(e,t={}){this.process(e.get("consequent"),t),this.process(e.get("alternate"),t)}process(e,t={}){e.isLogicalExpression()?this.processLogicalExpression(e,t):e.isObjectExpression()?this.processObjectExpression(e,t):e.isConditionalExpression()&&this.processConditionalExpression(e,t)}run(e,r){this.prepare(r);const n=e=>{if(!this.config.evaluate)return!1;const{value:r,error:n}=evaluate(e);if(n)return!1;const{className:s}=taddy.$css(r);if(this.options.mixin)return!0;const i=this.classNamesToNode(s);return e.replaceWith(t.objectExpression(mergeObjectProperties(i))),this.optimizationPaths.add(e),!0};let s=[].concat(e.get("arguments")),i=!0;for(let e of s)n(e)||(this.process(e),e.isObjectExpression()||(i=!1));const o=s.map(e=>e.node),a=s[0];if(this.variables.length>0&&o.push(t.objectExpression([t.objectProperty(t.identifier(core.VARS_KEY),t.objectExpression(this.variables))])),i){a.replaceWith(t.objectExpression(mergeObjects(o))),e.node.arguments=[a.node];const r=a,n=r.node.properties.every(e=>!!t.isObjectProperty(e)&&"name"in e.key&&!("_"!==e.key.name[0]&&"className"!==e.key.name&&"style"!==e.key.name&&e.key.name!==core.VARS_KEY&&!t.isBooleanLiteral(e.value)));return!this.options.mixin&&n&&optimizeStaticStyles(r),{isStatic:n,optimizationPaths:this.optimizationPaths}}return{isStatic:!1,optimizationPaths:this.optimizationPaths}}}let LAST_INDEX=0;function getStylesState(){const{rules:e}=taddy.ruleInjector.styleSheet;return{added:[...e.slice(LAST_INDEX)].map(e=>e.cssText||"")}}function resolveFilepath(e,...t){return"string"!=typeof e?e(...t):path.join(getRootDir(),e)}function getEnv(e){try{return e.env()}catch(e){}return process.env&&process.env.BABEL_ENV||"production"}function getMtime(e){return Number(fs.statSync(e).mtime)}const filesMap=new Map,contentMap=new Map;function readFileSync(e){let t="";try{const r=getMtime(e);if(filesMap.has(r))return filesMap.get(r);t=fs.readFileSync(e).toString(),filesMap.set(r,t),contentMap.set(t,r)}catch(e){}return t}function appendFile(e,t,r){contentMap.has(t+r)||("appendFileSync"in fs?fs.appendFileSync(e,r):fs.appendFile(e,r,()=>{}))}function output({config:{cssFilename:e=(()=>"taddy.css"),cssFilepath:t=((e="taddy.css")=>path.join(getCacheDir(),e))}={}}){const{added:r}=getStylesState(),n=resolveFilepath(e),s=resolveFilepath(t,n),i=readFileSync(s),o=r.filter(e=>!i.includes(e)).join("");appendFile(s,i,o)}function isPathRemoved(e){do{if(e.removed)return!0}while(e=e.parentPath);return!1}const createProcessors=(e,r)=>{const n=[],s=[],i=[],o=new Processor({config:e}),a=new BindingOptimizer;let c=0;const p=e=>{e.node.arguments.push(t.stringLiteral("__"+stringHash(path.relative(getRootDir(),r.filename)+":"+ ++c).toString(32)))};function l({path:e,mixin:t}){const n=o.run(e,_extends({},r,{mixin:t}));if(!n)return;const{isStatic:i,optimizationPaths:a}=n;s.push({path:e,isStatic:i,optimizationPaths:a}),t||p(e)}return{handlers:{css:(e,{mixin:t=!1}={})=>{e.isMemberExpression()&&"name"in e.node.property&&"mixin"===e.node.property.name?n.push(e.parentPath):e.isCallExpression()&&i.push({path:e,mixin:t})},mixin:e=>{n.push(e)}},finish(){i.forEach(l);let r=!1;if(e.optimizeBindings){r=!0;for(let e of s){r=r&&e.isStatic;for(let t of e.optimizationPaths)a.process(t)}}for(let t of n)e.optimizeBindings&&isPathRemoved(t)||(r=!1,l({path:t,mixin:!0}));if(!r)for(let e of s){if(!e.isStatic)continue;const{path:r}=e;r.replaceWith(t.callExpression(t.memberExpression(r.node.callee,t.identifier("static")),r.node.arguments))}return{isStatic:r}}}};function mapCompileOptions({filename:e,evaluate:t=!0,typescript:r=/\.tsx?$/.test(e),unstable_CSSVariableFallback:n=!0,unstable_optimizeBindings:s=!0,unstable_useTaggedTemplateLiterals:i=!1}){return{evaluate:t,typescript:r,CSSVariableFallback:n,optimizeBindings:s,useTaggedTemplateLiterals:i}}function macro({references:e,babel:r,state:n,config:s={}}){const{env:i=getEnv(r)}=s,o=_objectWithoutPropertiesLoose(s,["env"]);if(isTaddyEvaluation(n))return;const a=n.file.path,c=n.file.code,{filename:p}=n;let l=null;a.traverse({ImportDeclaration(e){const{node:r}=e;r.source.value!==PACKAGE_NAME&&r.source.value!==MACRO_NAME||(l=e,l.node.source=t.stringLiteral("taddy"),e.stop())}});const u=new Map,d=mapCompileOptions(_extends({filename:p},o.compileOptions)),{useTaggedTemplateLiterals:f}=d,h=_objectWithoutPropertiesLoose(d,["useTaggedTemplateLiterals"]),{handlers:g,finish:m}=createProcessors(h,{env:i,filename:p,code:c,addImport(e){if(!u.has(e)){const r=t.importSpecifier(t.identifier(`_${e}_`),t.identifier(e));u.set(e,r),assert(l,"There is no taddy imports"),l.node.specifiers.push(r)}return u.get(e).local}});for(const r in e)if(r in g)for(let n of e[r]){let e=n.parentPath,s=r;if("css"===r&&e.isMemberExpression()&&"name"in e.node.property&&"mixin"===e.node.property.name&&(e=e.parentPath,s="mixin"),f&&("css"===s||"mixin"===s)&&e.isTaggedTemplateExpression()){const r=taggedTemplateToObject(e);e.replaceWith(t.callExpression(e.node.tag,[r]))}g[s](e)}const{isStatic:y}=m();return y&&null!==l&&(l.node.source=t.stringLiteral("@taddy/core")),output({env:i,state:n,config:o.outputOptions}),{keepImports:!0}}function getImportNames(e){const t=e.node.local.name;return e.isImportSpecifier()?{localName:t,importedName:e.node.imported.name}:e.isImportDefaultSpecifier()?{localName:t,importedName:"default"}:{localName:t,importedName:"namespace"}}function findReferences(e){const t={};for(let r of e){const{localName:e,importedName:n}=getImportNames(r),s=r.scope.getBinding(e);(null==s?void 0:s.referencePaths)&&(t[n]=s.referencePaths)}return t}function plugin(e,t){const r=getEnv(e);return{name:"taddy",pre(){this.references={}},visitor:{ImportDeclaration(n,s){isTaddyEvaluation(s)||n.node.source.value===PACKAGE_NAME&&(Object.assign(this.references,findReferences(n.get("specifiers"))),(this.references.css||this.references.mixin)&&macro({references:this.references,babel:e,state:s,config:_extends({env:r},t)}))}}}}exports.default=plugin,exports.macro=macro;
//# sourceMappingURL=babel-plugin.cjs.production.min.js.map
